﻿---
-- Default values for the player saved variables
---
sConfig = {
	general = {
		allowDrag = true,
		allowSettingsClick = true,
		displayLocale = nil
	},
	messages = {
		playerFloating = true,
		playerChat = false,
		petFloating = true,
		petChat = false
	},
	averageDisplay = {
		visible = true,
		backdrop = true,
        header = true,
		playerKills = true,
		playerQuests = true,
		petKills = true
	},
	ldb = {
		allowTextColor = true,
		showIcon = true,
		showLabel = false,
		showText = true,
		textPattern = "default",
		text = {
			kills = true,
			quests = true,
			pet = true,
			xp = true,
			petxp = true,
			colorValues = false,
			verbose = false,
		},
		tooltip = {
			showDetails = true,
			showExperience = true
		}
	}
}
sData = {
	player = {
		killAverage = 0,
		questAverage = 0
	},
	pet = {
		killAverage = 0
	}
}

---
-- Verifies that all config values have a default value
-- (New values are sometimes not initialized if older versions of saved values exist)
---
function VerifyConfig()
	-- General
	if sConfig.general == nil then sConfig.general = {  } end
	if sConfig.general.allowDrag == nil then sConfig.general.allowDrag = true end
	if sConfig.general.allowSettingsClick == nil then sConfig.general.allowSettingsClick = true end
	if sConfig.general.displayLocale == nil then sConfig.general.displayLocale = GetLocale() end
	
	-- Messages
	if sConfig.messages == nil then sConfig.messages = {  } end
	if sConfig.messages.playerFloating == nil then sConfig.messages.playerFloating = true end
	if sConfig.messages.playerChat == nil then sConfig.messages.playerChat = false end
	if sConfig.messages.petFloating == nil then sConfig.messages.petFloating = true end
	if sConfig.messages.petChat == nil then sConfig.messages.petChat = false end
	
	-- averageDisplay
	if sConfig.averageDisplay == nil then sConfig.averageDisplay = {  } end
	if sConfig.averageDisplay.visible == nil then sConfig.averageDisplay.visible = true end
	if sConfig.averageDisplay.backdrop == nil then sConfig.averageDisplay.backdrop = true end
	if sConfig.averageDisplay.header == nil then sConfig.averageDisplay.header = true end
	if sConfig.averageDisplay.playerKills == nil then sConfig.averageDisplay.playerKills = true end
	if sConfig.averageDisplay.playerQuests == nil then sConfig.averageDisplay.playerQuests = true end
	if sConfig.averageDisplay.petKills == nil then sConfig.averageDisplay.petKills = true end

	-- LDB
	if sConfig.ldb == nil then sConfig.ldb = {  } end
	if sConfig.ldb.text == nil then sConfig.ldb.text = {  } end
	if sConfig.ldb.tooltip == nil then sConfig.ldb.tooltip = {  } end
	if sConfig.ldb.allowTextColor == nil then sConfig.ldb.allowTextColor = true end
	if sConfig.ldb.showIcon == nil then sConfig.ldb.showIcon = true end
	if sConfig.ldb.showLabel == nil then sConfig.ldb.showLabel = false end
	if sConfig.ldb.showText == nil then sConfig.ldb.showText = true end
	if sConfig.ldb.textPattern == nil then sConfig.ldb.textPattern = "default" end
	if sConfig.ldb.text.kills == nil then sConfig.ldb.text.kills = true end
	if sConfig.ldb.text.quests == nil then sConfig.ldb.text.quests = true end
	if sConfig.ldb.text.pet == nil then sConfig.ldb.text.pet = true end
	if sConfig.ldb.text.xp == nil then sConfig.ldb.text.xp = true end
	if sConfig.ldb.text.petxp == nil then sConfig.ldb.text.petxp = true end
	if sConfig.ldb.text.verbose == nil then sConfig.ldb.text.verbose = false end
	if sConfig.ldb.text.colorValues == nil then sConfig.ldb.text.colorValues = true end
	if sConfig.ldb.tooltip.showDetails == nil then sConfig.ldb.tooltip.showDetails = true end
	if sConfig.ldb.tooltip.showExperience == nil then sConfig.ldb.tooltip.showExperience = true end
end