﻿-----
-- LibDataBroker data-source
-- TODO: Clean the code up
----
local UPDATE_INTERVAL = 1
local updateIn = 0
local tooltipFrame = nil

local iconName = (UnitFactionGroup("player") == "Alliance") and "INV_Jewelry_TrinketPVP_01" or "INV_Jewelry_TrinketPVP_02"

local frame = CreateFrame("frame")
local ldb = LibStub:GetLibrary("LibDataBroker-1.1")
local dataobj = ldb:NewDataObject("XToLevel", {
	type = "data source",
	icon = "Interface\\Icons\\" .. iconName,
	text = "XToLevel",
	label = "XToLevel",
})

local function FindAnchor(frame)
	local xcenter, ycenter = frame:GetCenter()
	if not xcenter or not ycenter then 
		return "TOPLEFT", "BOTTOMLEFT" 
	end
	local hor = (xcenter > UIParent:GetWidth() * 2 / 3) and "RIGHT" or (xcenter < UIParent:GetWidth() / 3) and "LEFT" or ""
	local ver = (ycenter > UIParent:GetHeight() / 2) and "TOP" or "BOTTOM"
	
	return ver..hor, frame, (ver == "TOP" and "BOTTOM" or "TOP")..hor
end

function dataobj:OnEnter()
	GameTooltip:SetOwner(self, "ANCHOR_NONE")
	GameTooltip:SetPoint(FindAnchor(self))
	GameTooltip:ClearLines()

	tooltipFrame = self
	
	local labelColor, dataColor, footerColor
	
	if sConfig.ldb.allowTextColor then
		labelColor = { r=0.75, g=0.75, b=0.75 }
		dataColor = { r=0.9, g=1, b=0.9 }
		footerColor = { r=0.6, g=0.6, b=0.6 }
	else
		labelColor = {}
		dataColor = {}
		footerColor = {}
	end
	
	GameTooltip:AddLine("XToLevel")
	
	if cPlayer.level < cPlayer.maxLevel then
		GameTooltip:AddDoubleLine(L["Kills"] .. ":" , NumberFormat(cPlayer:GetAverageKillsRemaining()), labelColor.r, labelColor.g, labelColor.b, dataColor.r, dataColor.b, dataColor.b)
		GameTooltip:AddDoubleLine(L["Quests"] .. ":" , NumberFormat(cPlayer:GetAverageQuestsRemaining()), labelColor.r, labelColor.g, labelColor.b, dataColor.r, dataColor.b, dataColor.b)
		GameTooltip:AddLine(" ")
		
		if sConfig.ldb.tooltip.showDetails then
			GameTooltip:AddLine(L["Details Header"] .. ":")
			GameTooltip:AddDoubleLine(" " .. L["XP Per Kill"] .. ": " , NumberFormat(round(cPlayer:GetAverageKillXP(), 0)), labelColor.r, labelColor.g, labelColor.b, dataColor.r, dataColor.b, dataColor.b)
			GameTooltip:AddDoubleLine(" " .. L["XP Per Quest"] .. ": " , NumberFormat(round(cPlayer:GetAverageQuestXP(), 0)), labelColor.r, labelColor.g, labelColor.b, dataColor.r, dataColor.b, dataColor.b)
			GameTooltip:AddLine(" ")
		end
		
		if sConfig.ldb.tooltip.showExperience then
			local xpProgress = round((cPlayer.currentXP or 0) / (cPlayer.maxXP or 1) * 100, 1)
			local xpNeededTotal = cPlayer.maxXP - cPlayer.currentXP
			local xpNeededActual = cPlayer:GetKillsRequired(1) or "~"
			
			GameTooltip:AddLine(L["Experience Header"] .. ": ")
			GameTooltip:AddDoubleLine(" " .. L["XP Progress"] .. ": " , ShrinkNumber(UnitXP("player")) .. " / " .. ShrinkNumber(UnitXPMax("player")) .. " [" .. tostring(xpProgress) .. "%" .. "]", labelColor.r, labelColor.g, labelColor.b, dataColor.r, dataColor.b, dataColor.b)
			GameTooltip:AddDoubleLine(" " .. L["XP Rested"] .. ": " , ShrinkNumber(cPlayer:IsRested() or 0), labelColor.r, labelColor.g, labelColor.b, dataColor.r, dataColor.b, dataColor.b)
			GameTooltip:AddDoubleLine(" " .. L["Quest XP Required"] .. ": " , ShrinkNumber(xpNeededTotal), labelColor.r, labelColor.g, labelColor.b, dataColor.r, dataColor.b, dataColor.b)
			GameTooltip:AddDoubleLine(" " .. L["Kill XP Required"] .. ": " , ShrinkNumber(xpNeededActual), labelColor.r, labelColor.g, labelColor.b, dataColor.r, dataColor.b, dataColor.b)
			
			GameTooltip:AddLine(" ")
		end
	end
	
	if cPet.isActive then
		GameTooltip:AddLine(L["Pet Header"] .. ":")
		GameTooltip:AddDoubleLine(" " .. L["Kills"] .. ":" , NumberFormat(cPet:GetAverageKillsRemaining()), labelColor.r, labelColor.g, labelColor.b, dataColor.r, dataColor.b, dataColor.b)
		GameTooltip:AddDoubleLine(" " .. L["XP Per Kill"] .. ":" , NumberFormat(round(cPet:GetAverageKillXP(), 0)), labelColor.r, labelColor.g, labelColor.b, dataColor.r, dataColor.b, dataColor.b)
		
		local petXP, petMaxXP = GetPetExperience()
		GameTooltip:AddDoubleLine(" " .. L["XP Required"] .. ":" , NumberFormat(round((petMaxXP or 0) - (petXP or 0))), labelColor.r, labelColor.g, labelColor.b, dataColor.r, dataColor.b, dataColor.b)
		GameTooltip:AddLine(" ")
	end
	
	GameTooltip:AddLine(L["Click To Configure"], footerColor.r, footerColor.g, footerColor.b)

	GameTooltip:Show()
end

function dataobj:OnLeave()
	tooltipFrame = nil
	GameTooltip:Hide()
end

function dataobj.OnClick(self, button)
	-- TODO: Do something more interesting here...
	cDisplay.Config:Open("ldb")
end

function UpdateDataObject()
	if sConfig.ldb.showLabel then
		dataobj.label = L["XToLevel"]
	else
		dataobj.label = nil
	end
	
	if sConfig.ldb.showIcon then
		local iconName = (UnitFactionGroup("player") == "Alliance") and "INV_Jewelry_TrinketPVP_01" or "INV_Jewelry_TrinketPVP_02"
		dataobj.icon = "Interface\\Icons\\" .. iconName
	else
		dataobj.icon = nil
	end
	
	if sConfig.ldb.showText then
		if (cPlayer.level < cPlayer.maxLevel) or cPet.isActive then
			local showPlayer = (cPlayer.level < cPlayer.maxLevel)
			local showPet = cPet.isActive
			
			-- User is leveling, proceed normally.
			local playerProgress, playerProgressColor, petProgress, petProgressColor
			
			if showPlayer then
				playerProgress = round(cPlayer.currentXP / cPlayer.maxXP * 100, 1)
				playerProgressColor = GetProgressColor(playerProgress)
			end
				
			if showPet then
				petProgress = round(cPet.xp / cPet.maxXP * 100, 1)
				petProgressColor = GetProgressColor(petProgress)
			end
			
			-- Set up patterns. -- TODO: Place this in a seperate file?
			local patterns = {
				default = "{kills}{$seperator}{color=cfcfdf}{$label}:{/color} {progress}{$value}{/progress}{/kills}{quests}{$seperator}{color=cfcfdf}{$label}:{/color} {progress}{$value}{/progress}{/quests}{xp}{$seperator}{progress}[{$value}%]{/progress}{/xp}{pet}{$seperator}{color=cfcfdf}{$label}:{/color} {progress}{$value}{/progress}{/pet}{petxp}{$seperator}{progress}[{$value}%]{/progress}{/petxp}",
				minimal = "{kills}{progress}{$value}{/progress}{/kills}{quests}{color=cfcfdf}{$seperator}{/color}{progress}{$value}{/progress}{/quests}{xp}{color=cfcfdf}{$seperator}{/color}{progress}{$value}%{/progress}{/xp}{pet}{color=cfcfdf}{$seperator}{/color}{progress}{$value}{/progress}{/pet}{petxp}{color=cfcfdf}{$seperator}{/color}{progress}{$value}%{/progress}{/petxp}",
				minimal_dashed = "{kills}{progress}{$value}{/progress}{/kills}{quests}{color=cfcfdf}{$seperator}{/color}{progress}{$value}{/progress}{/quests}{xp}{color=cfcfdf}{$seperator}{/color}{progress}{$value}%{/progress}{/xp}{pet}{color=cfcfdf}{$seperator}{/color}{progress}{$value}{/progress}{/pet}{petxp}{color=cfcfdf}{$seperator}{/color}{progress}{$value}%{/progress}{/petxp}",
				brackets = "{kills}{progress}[{$value}]{/progress}{/kills}{quests}{progress}[{$value}]{/progress}{/quests}{xp}{progress}[{$value}%]{/progress}{/xp}{pet}{$seperator}{progress}[{$value}]{/progress}{/pet}{petxp}{progress}[{$value}%]{/progress}{/petxp}",
			}
			local seperators = {
				default = " ",
				minimal = "/",
				minimal_dashed = "-",
				brackets = "-",
			}
			
			-- Load the appropriate pattern, attempting to find one in the config.
			local newText = patterns.default
			local seperator = seperators.default
			if sConfig.ldb.textPattern ~= nil then
				newText = patterns[sConfig.ldb.textPattern]
				seperator = seperators[sConfig.ldb.textPattern]
			end
			
			-- Replace {color} tags
			if sConfig.ldb.allowTextColor then 
				newText = string.gsub(newText, "{color=([0-9A-Fa-f]+)}(.-){/color}", "|cFF%1%2|r")
			else
				newText = string.gsub(newText, "{color=[0-9A-Fa-f]+}(.-){/color}", "%1")

			end
			
			-- Prepare tags
			local useColors = (sConfig.ldb.allowTextColor and sConfig.ldb.text.colorValues)
			local tags = {
				[1] = { 
					tag = "kills",
					label = (sConfig.ldb.text.verbose and L["Kills"] ) or L["Kills Short"],
					value = (showPlayer and (round(cPlayer:GetAverageKillsRemaining()) or "~")) or nil,
					color = (useColors and playerProgressColor) or nil,
				},
				[2] = { 
					tag = "quests",
					label = (sConfig.ldb.text.verbose and L["Quests"] ) or L["Quests Short"],
					value = (showPlayer and (round(cPlayer:GetAverageQuestsRemaining()) or "~")) or nil,
					color = (useColors and playerProgressColor) or nil,
				}, 
				[3] = { 
					tag = "xp",
					label = (sConfig.ldb.text.verbose and L["XP"] ) or L["XP Short"],
					value = (showPlayer and (playerProgress or "~")) or nil,
					color = (sConfig.ldb.allowTextColor and playerProgressColor) or nil,
				},
				[4] = { 
					tag = "pet",
					label = (sConfig.ldb.text.verbose and L["Pet"] ) or L["Pet Short"],
					value = (cPet.isActive and (round(cPet:GetAverageKillsRemaining()))) or nil,
					color = (useColors and petProgressColor) or nil,
				},
				[5] = { 
					tag = "petxp",
					label = (sConfig.ldb.text.verbose and L["XP"] ) or L["XP Short"],
					value = (cPet.isActive and (petProgress or "~")) or nil,
					color = (sConfig.ldb.allowTextColor and petProgressColor) or nil,
				},
			}
			
			-- Replace values
			local isFirst = true
			for i, object in ipairs(tags) do
				if sConfig.ldb.text[object.tag] and object.value ~= nil then
					newText = string.gsub(newText, "{".. object.tag .."}(.-){/".. object.tag .."}", function(str)
						str = string.gsub(str, "{$label}", object.label)
						str = string.gsub(str, "{$value}", object.value)
						if object.color ~= nil then
							str = string.gsub(str, "{progress}(.-){/progress}", "|cFF".. object.color .."%1|r")
						else
							str = string.gsub(str, "{progress}(.-){/progress}", "%1")
						end
						if isFirst then
							str = string.gsub(str, "{$seperator}", "")
						else
							str = string.gsub(str, "{$seperator}", seperator)
						end
						return str
					end)
					isFirst = false
				else
					newText = string.gsub(newText, "{".. object.tag .."}.-{/".. object.tag .."}", "")
				end
			end
			dataobj.text = newText
			
		else
			-- Player is at max level and has no pets.
			if sConfig.ldb.customColors then
				dataobj.text = "|cFFaaaaaano data|r"
			else
				dataobj.text = "no data"
			end
		end
	else
		dataobj.text = nil
	end
end

frame:SetScript("OnUpdate", function(self, elap)
	updateIn = updateIn - elap
	if updateIn <= 0 then
		updateIn = UPDATE_INTERVAL
		UpdateDataObject()
		
		if tooltipFrame then
			dataobj.OnEnter(tooltipFrame)
		end
	end
end)